ServerEvents.recipes(event => {
    event.replaceInput({output: 'functionalstorage:storage_controller'},
        'minecraft:comparator',
        '#kubejs:grist/intelligent/basic'
    );
    event.replaceInput({output: 'functionalstorage:storage_controller'},
        'minecraft:quartz_block',
        'minecraft:andesite'
    );

    event.replaceInput({output: 'functionalstorage:framed_storage_controller'},
        'minecraft:quartz_block',
        'minecraft:andesite'
    );
    event.replaceInput({output: 'functionalstorage:framed_storage_controller'},
        'minecraft:comparator',
        '#kubejs:grist/intelligent/basic'
    );

    event.replaceInput({output: 'functionalstorage:linking_tool'},
        'minecraft:diamond',
        '#kubejs:grist/intelligent/basic'
    );

    event.replaceInput({mod: 'functionalstorage'},
        'minecraft:piston',
        '#kubejs:grist/build/basic'
    );

    event.replaceInput({mod: 'functionalstorage'},
        'minecraft:netherite_ingot',
        '#kubejs:grist/intelligent/improved'
    );
});